#!/bin/bash

max=11

rm oland_ntimes*.f
rm output.*

for (( c=2; c<=$max; c++ ))
do
   cat oland_newatcf_template.f | sed s/MAX/$c/g > oland_ntimes$c.f
   f77 oland_ntimes$c.f
   echo "Running for ntimes= " $c
   ./a.out
   cp fort.12 output.$c
   rm -f a.out fort.12
done


# Compare output files with the same timestamp, with the
# intention of discarding the line with the lowest amount
# of forecast hours, meaning the shortest track.

rm -f longestTrack sortedOutput

for (( c=2; c<=$max; c++ ))
do
  while read line           
  do           
    m=`echo $line | awk -F' ' '{print $1}'`
    found=0
    for(( d=$max; d>$c ; d-- ))
    do
      if [ "$(grep -s $m output.$d)" ]; then
         found=1
         break
      fi
    done
    if [ $found = 0 ]; then
      echo $line >> longestTrack
    fi
  done < output.$c

done

sort -k 1,1 -k 7n,7 longestTrack > sortedOutput

exit
