      PROGRAM distcheck
      parameter (ntimes=MAX)
      character*4 model
      character*8 date
      character*80 line
      real rlat(ntimes),rlon(ntimes),times(11),latint(ntimes),
     1     lonint(ntimes),
     2     dmsave(240),distlatsave(240),distlonsave(240),
     3     rlandlat(250000),rlandlon(250000),tracklatsave(240),
     4     tracklonsave(240)
      data times/0.,12.,24.,36.,48.,60.,72.,84.,96.,108.,120./
c
  100 format(a80)
  110 format(14x,10(i4))
  720 format(2(1x,f11.6))
c
c     read land information
c
      open(unit=72,file='landfall.dat',form='formatted')
      icount=0
      do i=1,250000
        read(72,720,end=7299)rlandlat(i),rlandlon(i)
c       write(6,*)'i,rlandlat,rlandlon=',i,rlandlat(i),rlandlon(i)
        icount=icount+1
c       write(6,*)' icount=',icount
      end do
c
c     call readland(rlandlat,rlandlon,icount)
c
c     open atcf file
c
 7299 icount=icount-1
c     write(6,*)' icount=',icount
      open(unit=11,status='old',form='formatted')
c
c     read line
c
 10   read(11,100,end=99)line
      write(6,100)line
c
c     break out initial position and track for various models
c
      if (line(25:28) .eq. 'CARQ' .and. line(31:33) .eq. '  0') then
        rlat(ntimes)=0.
        rlon(ntimes)=0.
        date = line(11:18)
        read(line(36:38),'(i3)')lat
        read(line(42:45),'(i4)')lon
        rlat(1)=float(lat)/10.
        rlon(1)=float(lon)/10.
        read(11,100,end=99)line
c      elseif(line(25:28).eq.'AVNO'.or.line(25:28).eq.'AVNN'.or.
c     1       line(25:28).eq.'GFAL'.or.line(25:28).eq.'GFNO'.or.
c     1       line(25:28).eq.'VBAL'.or.line(25:28).eq.'VBNO'.or.
c     1       line(25:28).eq.'AVAL'.or.line(25:28).eq.'GFDL'.or.
      elseif(line(25:28).eq.'OFCL')then
        model=line(25:28)
        read (line,109)cdate,mnum,mnamef,iftm,ilat1,ilon1,ivmax1
  109   format(10x,a8,2x,a2,2x,a4,2x,i3,2x,i3,3x,i4,3x,i3)
        if(mod(iftm,12).eq.0.and.iftm.le.(ntimes-1)*12)then
          itmctr=iftm/12+1
        else
          goto 10
        endif
        rlat(itmctr)=float(ilat1)/10.
        rlon(itmctr)=float(ilon1)/10.
      else
        rlat(ntimes)=0.
        rlon(ntimes)=0.
        goto 10
      endif

      if(rlat(ntimes).ne.0..and.rlon(ntimes).ne.0.)then
c       call csint(ntimes,times,rlat,latint,cscoeflat)
c       call csint(ntimes,times,rlon,lonint,cscoeflon)
        call sspline(times,rlat,ntimes,latint)
        call sspline(times,rlon,ntimes,lonint)
        do ijk=1,(ntimes-1)*24
          timechk=float(ijk)/2.
c         clat=csval(timechk,ntimes,latint,cscoeflat)
c         clon=csval(timechk,ntimes,lonint,cscoeflon)
          clat=splint(times,rlat,latint,ntimes,timechk)
          clon=splint(times,rlon,lonint,ntimes,timechk)
          tracklatsave(ijk)=clat
          tracklonsave(ijk)=clon
c         write(6,*)clat,clon,rlandlat,rlandlon,icount
          call distchk(clat,clon,dm,distlat,distlon,rlandlat,rlandlon,
     1                 icount)
          dmsave(ijk)=dm
          distlatsave(ijk)=distlat
          distlonsave(ijk)=distlon
        end do
        do i=3,(ntimes-1)*24-2
          if(dmsave(i).lt.dmsave(i-2).and.
     1       dmsave(i).lt.dmsave(i+2).and.
     2       dmsave(i).lt.dmsave(i-1).and.
     3       dmsave(i).lt.dmsave(i+1).and.
     4       dmsave(i)*111.1.lt.500.)then
            dmwrite=dmsave(i)*111.1
            write(12,120)model,date,dmwrite,distlatsave(i),
     1                   distlonsave(i),tracklatsave(i),
     1                   tracklonsave(i),float(i)/2.,ivmax1,iftm
            write(6,120)model,date,dmwrite,distlatsave(i),
     1                   distlonsave(i),tracklatsave(i),
     1                   tracklonsave(i),float(i)/2.,ivmax1,iftm
            do m=1,ntimes
              rlat(m)=0.
              rlon(m)=0.
            end do
          endif
        end do
      endif
      goto 10
 120  format(a4,a8,6(f7.2,1x),i4,i6)
  99  stop
      end                                                        
      subroutine distchk(slat,slon,distmin,distlat,distlon,rlat,rlon,
     1                   icount)
      data pi,dtr/3.141593,.0174532925/
c
c     slat, slon is storm location
c
      real rlat(icount),rlon(icount)
c
c     set initial values based upon storm location.  Longitude west is positive
c
c     write(6,*)' icount=',icount
      distmin=9999.
      do i2=1,icount
        if(rlat(i2)-slat.lt.5.or.rlon(i2)-slon.lt.5)then
          dlat=abs(rlat(i2)-slat)
          dlon=abs(rlon(i2)-slon)*cos(0.5*dtr*(rlat(i2)+slat))
          disttst=sqrt(dlat**2+dlon**2)
          if(disttst.lt.distmin)then
            distmin=disttst
            distlat=rlat(i2)
            distlon=rlon(i2)
          endif
        endif
      end do
c      write(6,*)distlat,distlon,slat,slon,distmin
      return
      end
      subroutine sspline(x,y,n,y2)
      implicit none

      integer n, NMAX
      parameter (NMAX=150)

      real x(n), y(n), y2(n), yp1, ypn

c     print*,'SSPLINE:       y2,y1 = ',y(2),y(1)
c     print*,'SSPLINE: y(n),y(n-1) = ',y(n),y(n-1)
c     print*,'SSPLINE:       x2,x1 = ',x(2),x(1)
c     print*,'SSPLINE: x(n),x(n-1) = ',x(n),x(n-1)

      yp1 = (y(2)-y(1))/(x(2)-x(1))
      ypn = (y(n)-y(n-1))/(x(n)-x(n-1))

c     print*,'SSPLINE: N,YP1,YPN = ',n,yp1,ypn

      call spline(x,y,n,yp1,ypn,y2)

      return

      end

      real function splint(xa,ya,y2a,n,x)
      INTEGER n
      REAL x,y,xa(n),y2a(n),ya(n)
      INTEGER k,khi,klo
      REAL a,b,h
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
            k=(khi+klo)/2
            if(xa(k).gt.x)then
                  khi=k
            else
                  klo=k
            endif
            goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.) pause 'bad xa input in splint'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+
     *  ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.
      splint = y
      return
      END

      SUBROUTINE spline(x,y,n,yp1,ypn,y2)
      INTEGER n,NMAX
      REAL yp1,ypn,x(n),y(n),y2(n)
      PARAMETER (NMAX=500)

      INTEGER i,k
      REAL p,qn,sig,un,u(NMAX)
      if (yp1.gt..99e30) then
            y2(1)=0.
            u(1)=0.
      else
            y2(1)=-0.5
            u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      do i=2,n-1
            sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
            p=sig*y2(i-1)+2.
            y2(i)=(sig-1.)/p
            u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))
     *           /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
      enddo
      if (ypn.gt..99e30) then
            qn=0.
            un=0.
      else
            qn=0.5
            un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
      do k=n-1,1,-1
            y2(k)=y2(k)*y2(k+1)+u(k)
      enddo
      return
      END


